
dskellam=function(x,mu,sigma2)
  {
    theta1=(sigma2+mu)/2
    theta2=(sigma2-mu)/2    
    exp(-(theta1+theta2)) *(theta1/theta2)^(x/2)*besselI(2*sqrt(theta1*theta2),nu=abs(x))
  }

cond=function(z,x,mu,sigma2,a)
  {
    if ( (x >=0)&(a>=0))
      {
        s=0:x
        r=(z-s)
        x1=dbinom(s,x,a)
        x2=dskellam(r,mu,sigma2)
        temp=sum(x1*x2) 
      } 
    if ((x<0)&(a>=0))
      {
        s=x:0
        r=(z-s)
        x1=dbinom(-s,abs(x),a)
        x2=dskellam(r,mu,sigma2)        
        temp=sum(x1*x2)
      }
    if ((x>=0)&(a<0))
      {
        s=  -x:0
        r=(z-s)
        x1=dbinom(-s,abs(x),abs(a))
        x2=dskellam(r,mu,sigma2)        
        temp=sum(x1*x2)
      }
    if ((x<0)&(a<0))
      {
        s= 0: (-x)
        r=(z-s)
        x1=dbinom(s,abs(x),abs(a))
        x2=dskellam(r,mu,sigma2)                
        temp=sum(x1*x2)
      }
    temp
  }


condloglik=function(theta,data)
  {
    mu=theta[1]
    sigma2=theta[2]
    a=theta[3]
    n=length(data)
    temp=0
    for (i in 2:n)
      {
        temp=temp + log(cond(data[i],data[i-1],mu,sigma2,a))
      }
    return(-temp)
  }

condloglikreg=function(theta,data,covar)
  {
    mu=theta[1]+theta[2]*covar
    sigma2=theta[3]
    a=theta[4]
    n=length(data)
    temp=0
    for (i in 2:n)
      {
        temp=temp + log(cond(data[i],data[i-1],mu[i],sigma2,a))
      }
    return(-temp)
  }


# READ DATA
xydata=as.matrix(read.table("tickdata2.dat",header=T))
y=xydata[,1]
x=xydata[,2]

# ESTIMATE FULL MODEL
lambda1=0.3
lambda2=0.3
a=-0.25
mu=lambda1-lambda2
sigma2=lambda1+lambda2
ML=nlm(condloglik,c(mu,sigma2,a),data=y,hessian=T)
start=ML$estimate
#ML=optim(c(mu,sigma2,a),condloglik,data=y,hessian=T,method="SANN")
#start=ML$par
covma=ML$hessian
stderr=sqrt(diag(solve(covma)))

# ESTIMATE FULL MODEL WITH REGRESSOR
x[x>1e4]=1e4
regML=nlm(condloglikreg,c(start[1],0,start[2],start[3]),data=y,covar=x,hessian=T,gradtol=1e-10,steptol=1e-6,fscale=1000)
regML=nlm(condloglikreg,c(mu,0,sigma2,a),data=y,covar=x,hessian=T,gradtol=1e-10,steptol=1e-6,fscale=1000)
#regML=nlminb(c(start[1],0,start[2],start[3]),condloglikreg,data=y,covar=x)
#regML=optim(c(start[1],0,start[2],start[3]),condloglikreg,data=y,covar=x,hessian=T,method="SANN")
regcovma=regML$hessian
regstderr=sqrt(diag(solve(regcovma)))
LR=2*(ML$minimum-regML$minimum)
pval=1-pchisq(LR,df=1)
LR
pval